-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

M.type = "engine"
M.relevantDevice = nil
local fuel = 0

local function init(jbeamData)
	electrics.values.sound = jbeamData.engine
	electrics.values.airfuel = jbeamData.airfuel
	electrics.values.thrust = 0
	fuel = jbeamData.airfuel
end

local function onReset()
	electrics.values.airfuel = fuel
end

local function updateGFX(dt)
	if electrics.values.airfuel > 0 then
		electrics.values.airfuel = math.max(electrics.values.airfuel - (electrics.values.thrust_control+0.02)*dt*0.5,0)
		electrics.values.thrust = electrics.values.thrust_control
	else
		if electrics.values.thrust > 0 then
			 electrics.values.thrust = math.max(electrics.values.thrust-1*dt,0)
		end
		if electrics.values.sound > 0 then
			 electrics.values.sound = math.max(electrics.values.sound-0.5*dt,0)
		end
	end
end

-- public interface
M.init    = init
M.updateGFX = updateGFX
-------------------------------

return M