-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local ist_nick
local ist_roll
local ist_yaw
local ist_airbrake
local ist_gear
local soll_nick
local soll_roll
local soll_yaw
local soll_airbrake
local soll_gear

local function onReset()
  electrics.values['elevator'] = 0
  electrics.values['rudder'] = 0
  electrics.values['aileron'] = 0
  electrics.values['airbrake'] = 0
  electrics.values['landinggear'] = 0
  electrics.values['vario'] = 0
  electrics.values['thrust_control'] = 0
  ist_nick   = 0
  ist_roll   = 0
  ist_yaw    = 0
  ist_airbrake  = 0
  ist_gear   = 0
  ist_thrust  = 0
  soll_nick  = 0
  soll_roll  = 0
  soll_yaw   = 0
  soll_airbrake = 0
  soll_gear  = 0
  soll_thrust  = 0
  
end

function balance(soll_value,ist_value,presicion,speed,dt)
	if (ist_value-soll_value)>presicion then
		return ist_value-speed*dt
	end
	if (ist_value-soll_value)<-presicion then
		return ist_value+speed*dt
	end
	return soll_value
end

local function updateGFX(dt) -- ms
	ist_nick = balance(soll_nick,ist_nick,0.05,3,dt)
	ist_yaw = balance(soll_yaw,ist_yaw,0.05,3,dt)
	ist_roll = balance(soll_roll,ist_roll,0.05,3,dt)
	ist_airbrake = balance(soll_airbrake,ist_airbrake,0.05,3,dt)
	ist_gear = balance(soll_gear,ist_gear,0.05,3,dt)
	ist_thrust = balance(soll_thrust, ist_thrust, 0.05, 0.2,dt)
	electrics.values['elevator'] = ist_nick
	electrics.values['rudder'] = ist_yaw
	electrics.values['aileron'] = ist_roll
	electrics.values['airbrake'] = ist_airbrake
	electrics.values['landinggear'] = ist_gear
	electrics.values.brake = ist_airbrake
	electrics.values['thrust_control'] = ist_thrust
end

local function roll(str,value,fltr)
  soll_roll = value
end

local function nick(str,value,fltr)
  soll_nick = value
end

local function yaw(str,value,fltr)
  soll_yaw = value
end

local function airbrake(str,value,fltr)
  soll_airbrake = value
end

local function thrust(str,value,fltr)
	soll_thrust = value
end

local function toggle_airbrake(str,value,fltr)
	if soll_airbrake == 0 then
		soll_airbrake = 1
	else
		soll_airbrake = 0
	end
end

local function toggle_thrust(str,value,fltr)
	if soll_airbrake == 0 then
		soll_airbrake = 1
	else
		soll_airbrake = 0
	end
end

local function toggle_gear(str,value,fltr)
	if soll_gear == 0 then
		soll_gear = 1
		gui.message("Landinggear up", 2, "systemmessage")
	else
		soll_gear = 0
		gui.message("Lamdinggear down", 2, "systemmessage")
	end
end

local function toggle_vario(str,value,fltr)
	if electrics.values['vario'] == 0 then
		electrics.values['vario'] = 1
	else
		electrics.values['vario'] = 0
	end
end

-- public interface 
M.onInit    = onReset
M.onReset   = onReset
M.updateGFX = updateGFX
M.roll = roll
M.nick = nick
M.yaw = yaw
M.airbrake = airbrake
M.thrust = thrust
M.toggle_airbrake = toggle_airbrake
M.toggle_gear = toggle_gear
M.toggle_vario = toggle_vario
M.toggle_thrust = toggle_thrust

return M
