-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local s_gear_u
local s_gear_d
local s_brake_c
local s_brake_o
local l_brake
local l_gear
local nodes = 0

local function onInit()
	s_gear_u  = false
	s_gear_d  = false
	s_brake_c = false
	s_brake_o = false
	l_brake = 0
	l_gear = 0
  for k, node in pairs (v.data.nodes) do
	if node.name == "body35" then nodes = k end
  end
end

local function onReset()
	s_gear_u  = false
	s_gear_d  = false
	s_brake_c = false
	s_brake_o = false
	l_brake = 0
end

local function updateGFX(dt) -- ms
	local curbrake = electrics.values['airbrake']
	local curgear = electrics.values['landinggear']
	
	if (curgear < l_gear and l_gear >= 0.99 ) and not s_gear_d then
		sounds.playSoundOnceAtNode("dg100gearin", nodes, 2)
		s_gear_d  = true	
	else
		s_gear_d  = false
	end
	
	if (curgear > l_gear and curgear == 1 ) and not s_gear_u then
		sounds.playSoundOnceAtNode("dg100gearout", nodes, 2.5)
		s_gear_u  = true	
	else
		s_gear_u  = false
	end
	
	if (curbrake <= 0.01 and l_brake > curbrake) and not s_brake_c then
		sounds.playSoundOnceAtNode("dg100brakesin", nodes, 2.4)
		s_brake_c = true
	else 
		s_brake_c = false
	end
	
	if (l_brake == 0 and curbrake > l_brake) and not s_brake_o then
		sounds.playSoundOnceAtNode("dg100gearout", nodes, 2.4)
		s_brake_o = true
	else 
		s_brake_o = false
	end
	
	l_brake = curbrake
	l_gear = curgear
end

-- public interface
M.onInit    = onInit
M.onReset   = onReset
M.updateGFX = updateGFX

return M
