-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
local lastSpeed = 0
local v = {}

local function onInit()
	electrics.values['vsi_vario'] = 0
	lastSpeed = electrics.values['airspeed']
	electrics.values.rollDeg  = 0
	electrics.values.pitchDeg = 0
	electrics.values.yawDeg   = 0
	for k = 0,15,1 do
		v[k] = 0
	end
end

local function onReset()
	onInit()
end

local function smooth(value)
	local sum = 0
	v[16] = value
	for k = 0,15,1 do
		sum = sum + v[k]
		v[k] = v[k+1]
	end
	return sum/16
end

local function updateGFX(dt)
	local vel = vec3(obj:getVelocity())
	local curSpeed = electrics.values['airspeed']
	local metersPerSecond = vel.z - 2.1 * (lastSpeed - curSpeed) / dt 
	electrics.values['vsi_vario'] = math.min(10,math.max(-10,smooth(metersPerSecond)))
	lastSpeed = curSpeed
end

-- public interface
M.onInit      = onInit
M.onReset     = onReset
M.updateGFX = updateGFX

return M